/*
 * Copyright 2006 Takahiro Nakamura.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package woolpack.utils.concurrent;

import junit.framework.TestCase;

public class AcquirableConstantsTest extends TestCase {
	private int count = 100;
	
	public void testAny(){
		for(int i=0; i<count; i++){
			assertTrue(AcquirableConstants.ANY.acquire());
		}
		for(int i=0; i<count; i++){
			AcquirableConstants.ANY.release();
		}
	}
	
	public void testNone(){
		for(int i=0; i<count; i++){
			AcquirableConstants.NONE.release();
		}
		for(int i=0; i<count; i++){
			assertFalse(AcquirableConstants.NONE.acquire());
		}
	}
	
	public void testInterrupt(){
		assertFalse(AcquirableConstants.INTERRUPT.acquire());
		assertTrue(Thread.currentThread().isInterrupted());
		Thread.interrupted();
		AcquirableConstants.INTERRUPT.release();
	}
	
	public void testInterruptedException(){
		try{
			AcquirableConstants.INTERRUPTED_EXCEPTION.acquire();
			fail();
		}catch(final RuntimeException e){
			assertTrue(e.getCause() instanceof InterruptedException);
		}
		assertTrue(Thread.currentThread().isInterrupted());
		Thread.interrupted();
		AcquirableConstants.INTERRUPTED_EXCEPTION.release();
	}
}
